searchData={"items":[{"type":"module","title":"MarkdownCodeBlockFormatter","doc":"Elixir formatter plugin for formatting Elixir code in Markdown files.","ref":"MarkdownCodeBlockFormatter.html"},{"type":"function","title":"MarkdownCodeBlockFormatter.features/1","doc":"","ref":"MarkdownCodeBlockFormatter.html#features/1"},{"type":"function","title":"MarkdownCodeBlockFormatter.format/2","doc":"","ref":"MarkdownCodeBlockFormatter.html#format/2"},{"type":"extras","title":"Markdown Code Block Formatter","doc":"# Markdown Code Block Formatter\n\n![GitHub Workflow status](https://github.com/angelikatyborska/markdown_code_block_formatter/actions/workflows/test.yml/badge.svg)\n![version on Hex.pm](https://img.shields.io/hexpm/v/markdown_code_block_formatter)\n![number of downloads on Hex.pm](https://img.shields.io/hexpm/dt/markdown_code_block_formatter)\n![license on Hex.pm](https://img.shields.io/hexpm/l/markdown_code_block_formatter)\n\nAn Elixir formatter for Elixir code blocks in Markdown files and sigils.\n\nIt will **not** format any other part of your Markdown files.\n\n![Running mix format formats your Elixir code in Markdown](https://raw.github.com/angelikatyborska/markdown_code_block_formatter/main/assets/mix-format.gif)","ref":"readme.html"},{"type":"extras","title":"Installation - Markdown Code Block Formatter","doc":"The package can be installed by adding `markdown_code_block_formatter` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:markdown_code_block_formatter, \"~> 0.1.0\", runtime: false}\n  ]\nend\n```\n\nThen, extend your `.formatter.exs` config file by adding the plugin and inputs matching the location of your Markdown files. \n\n```elixir\n# .formatter.exs\n[\n  plugins: [MarkdownCodeBlockFormatter],\n  inputs: [\n    # modify the line below to match the locations of your Markdown files\n    \"{docs,help}/*.{md,markdown}\",\n    # other files ...\n  ]\n]\n```\n\nElixir 1.13 or up is required because lower versions do not support formatter plugins.","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Markdown Code Block Formatter","doc":"Run `mix format`.\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Disabling the formatter for specific code blocks - Markdown Code Block Formatter","doc":"If you want some of the Elixir code blocks to remain unformatted, you can precede the code block with a special [\"comment\"](https://www.jamestharpe.com/markdown-comments/):\n\n````markdown\n[//]: # (elixir-formatter-disable-next-block)\n\n```elixir\n# the two calls below are equivalent:\nmy_function(opt1: true, opt2: 60)\nmy_function([opt1: true, opt2: 60])\n```\n````\n\nNote that Markdown does not have a syntax for comments, and the above is just a [reference-style link syntax](https://www.markdownguide.org/basic-syntax/#reference-style-links).","ref":"readme.html#disabling-the-formatter-for-specific-code-blocks"},{"type":"extras","title":"Known limitations - Markdown Code Block Formatter","doc":"#","ref":"readme.html#known-limitations"},{"type":"extras","title":"Whitespace stripping on empty lines - Markdown Code Block Formatter","doc":"Imagine your Elixir code blocks are indented in your Markdown file. Like this:\n\n````markdown\n- This code block is part of the list item:\n  ```elixir\n  a = rem(x, 2)\n\n  a * 10\n  ```\n````\n\nOn line nr 4, you could either have no characters, or have 2 spaces. This formatter will always strip all of your whitespaces from empty lines in Elixir code, forcing you into option 1.\n\nThis is my preferred behavior, but it should be possible to extend the formatter to accept an option that lets you choose either of the two. Let me know if you need that by opening a GitHub issue. \n\n#","ref":"readme.html#whitespace-stripping-on-empty-lines"},{"type":"extras","title":"Indented (not fenced) code blocks - Markdown Code Block Formatter","doc":"TL;DR: This formatter doesn't work well with indented code blocks. Use fenced code blocks instead.\n\nGenerally, this formatter will only format code blocks annotated as Elixir, and only fenced code blocks can specify their syntax. But that's not what this limitation is about.\n\nParsing indented code blocks is not implemented at all, which means all content inside an indented code block will be further parsed as Markdown. If your indented code block contains a fenced Elixir code block as content, that Elixir code block will get formatted even though it shouldn't.\n\nI decided to ignore indented code blocks to simplify the parser implementation and save time.","ref":"readme.html#indented-not-fenced-code-blocks"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.1.0 (2024-01-20) - Changelog","doc":"- Initial release.","ref":"changelog.html#0-1-0-2024-01-20"}],"content_type":"text/markdown"}